routes/web.php
<?php

use App\Http\Controllers\Admin\NewsController;
use App\Http\Controllers\Admin\ServicesController;
use App\Http\Controllers\Admin\AwardsController;

// use App\Http\Controllers\AwardsController;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\MediaController;
use App\Http\Controllers\NewsController as ControllersNewsController;
use App\Http\Controllers\NProductController;
use App\Http\Controllers\ServiceController;
use App\Models\Banner;
use App\Models\Customer;
use App\Models\News;
use App\Models\Partner;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
//website routes
Route::get('/test',function(){
    return view('test');
});
Route::get('/', function () {
    $banners = Banner::limit(10)->get();
    $categories = App\Models\Category::whereNull('parent_id')->get();
    $news =News::orderBy('created_at')->limit(4)->get();
    return view('welcome', compact('banners', 'categories','news'));
})->name('home');
Route::get('/about-us', function () {
    $partners = Partner::all();
    $customers = Customer::all();
    return view('about-us', compact('partners', 'customers'));
})->name('about.us');
Route::get('/business-lines/{category}', [CategoryController::class, 'show'])->name('category.show');
Route::get('/media', [MediaController::class, 'index'])->name('media.show');
Route::get('/product/{product}', [NProductController::class, 'show'])->name('wproduct.show');
Route::get('/news/{new}', [ControllersNewsController::class, 'show'])->name('newsa.show');
Route::get('/news', [ControllersNewsController::class, 'index'])->name('newsa.index');

Route::get('/services/{service}', [ServiceController::class, 'show'])->name('service.show');
Route::get('/awards', [AwardsController::class, 'index'])->name('awardsa.index');
Route::get('/contact-us', function () {
    return view('contact-us');
})->name('contact.us');
Route::post('/contact-us/store', function () {
    return redirect()->route('home');
})->name('contact.us.submit');

Route::get('/privacy', function () {
    return view('privacy');
})->name('privacy');


//admin routes
Route::group(
    ['prefix' => 'admin', 'namespace' => 'App\Http\Controllers\Admin'],
    function () {
        Route::group(['namespace' => 'Auth'], function () {
            Route::get('login', 'LoginController@showLoginForm')->name('login');
            Route::post('login', 'LoginController@login')->name('login_submit');
            Route::post('logout', 'LoginController@logout')->name('logout');
        });

        Route::group(['middleware' => ["auth"]], function () {
            Route::get('dashboard', 'DashboardController@index')->name('dashboard');
            //categories
            Route::resource('categories', 'CategoriesController')->except('create');
            //awards
            Route::resource('awards', 'AwardsController')->except('create');
            Route::post('categories/subadd/{parent}', 'CategoriesController@storesub')->name('categories.storesub');

            //vacancies
            Route::resource('vacancies', 'VacanciesController');
            Route::resource('requests', 'RequestsController');

            //users
            Route::resource('users', 'UsersController')->except('create');

            Route::resource('profile', 'ProfileController');

            Route::resource('news', 'NewsController');
            Route::resource('products', 'ProductsController');

            Route::get('products/preview_product/{id}', 'ProductsController@preview')->name('products.preview');

            Route::resource('services', 'ServicesController');
            Route::resource('partners', 'PartnersController');
            Route::resource('customers', 'CustomersController');


            Route::get('services/preview_services/{id}', ('ServicesController@preview'))->name('service.preview');



            Route::put('profile/{profile}/update_password', 'ProfileController@update_password')->name('profile.update_password');
        });
    }

);

app/Models/Category.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Kyslik\ColumnSortable\Sortable;
use Spatie\Activitylog\Traits\LogsActivity;

class Category extends SuperScope
{
    use HasFactory;
    use Sortable;

    protected $fillable = ['name', 'ar_name','fr_name', 'parent_id','description','ar_description','fr_description'];

    public $sortable = [
        'id',
        'name', 'ar_name','fr_name'
    ];
    public $sortableAs = ['childs_count'];

    public function parent()
    {
        return $this->belongsTo(\App\Models\Category::class, 'parent_id');
    }
    public function childs()
    {
        return $this->hasMany(\App\Models\Category::class, 'parent_id');
    }
    public function Products()
    {
        return $this->hasMany(Products::class);
    }
    public function services()
    {
        return $this->hasMany(Services::class);
    }
    public static function parents(){
        self::whereNull('parent_id');

    }
    public function getImageAttribute($value){
        if(!$value) return asset('covers/cover1.png');
        return asset('files/categories/images/'.$value);
    }
    public function getCoverAttribute($value){
        if(!$value) return asset('covers/cover2.png');
        return asset('files/categories/images/'.$value);
    }

}

app/Models/Customer.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Kyslik\ColumnSortable\Sortable;

class Customer extends SuperScope
{
    use HasFactory;
    use HasFactory;
    use Sortable;

    protected $fillable = ['name', 'ar_name', 'description', 'fr_description', 'ar_description', 'image', 'fr_name'];

    public $sortable = [
        'id',
        'name', 'ar_name',
    ];
    public function getImageAttribute($value)
    {
        return asset('files/general/images/' . $value);
    }
}

app/Http/Controllers/Admin/CustomersController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Misc\Helpers\FileHandler;
use App\Models\Customer;
use App\Http\Requests\Admin\CreateNewCustomerRequest;
use App\Http\Requests\Admin\UpdateCustomerRequest;

use Illuminate\Http\Request;

class CustomersController extends Controller
{
    public function index(Customer $customers, Request $request)
    {
        $data = Customer::dates($request->dates);
        $data = $data->searchIn(["name", "ar_name", "fr_name", "description"], $request->search_input);

        $data = $data->sortable('id', 'desc')
            ->paginate(15)->withQueryString();
        return view('admin.customers.index', compact('data'));
    }


    public function store(CreateNewCustomerRequest $request)
    {
        $record = Customer::create([
            "name" => $request->name,
            "ar_name" => $request->ar_name,
            "fr_name" => $request->fr_name,
            "description" => $request->description,
            "ar_description" => $request->ar_description,
            "fr_description" => $request->fr_description,
            "image" =>  $request->file('image') ? FileHandler::store_img($request->image, 'general_images') : null,
        ]);
        $record->save();

        return redirect()->back()->with(["message" => "You have add a new Customer"]);
    }


    public function show(Customer $customer)
    {
        $customer->name;
        $customer->ar_name;
        $customer->fr_name;
        $customer->description;
        $customer->image;
    }



    public function update(Customer $customer, UpdateCustomerRequest $request)
    {

        $customer->name = $request->name;
        $customer->ar_name = $request->ar_name;
        $customer->fr_name = $request->fr_name;
        $customer->description = $request->input('description' . $customer->id);
        $customer->ar_description = $request->input('ar_description' . $customer->id);
        $customer->fr_description = $request->input('fr_description' . $customer->id);
        if (empty($request->new_image)) {
        } else {
            $customer->image =  $request->file('new_image') ? FileHandler::store_img($request->new_image, 'general_images') : null;
        }

        $customer->save();
        return redirect()->back()->with(["message" => "You have update the customer information"]);
    }




    public function destroy(Customer $customer)
    {
        $customer->delete();
        return redirect()->back()->with(["message" => "You have delete a customer"]);
    }
}

resources/views/admin/customers/index.blade.php
@extends('layouts.dashboard')
@section('content')

    <x-content-header />
    <x-content-subheader>
        <x-button-add button class=" btn-success " type="button" data-bs-toggle="modal" data-bs-target="#create-modal">
            Add customer
        </x-button-add>
        <x-modal formid="addcustomer" id="create-modal" method="post" action="{{ route('customers.store') }}">
            <x-slot name="header"> Add customer
            </x-slot>
            <x-slot name="body">
                @include('admin._forms.create-customer')
            </x-slot>
        </x-modal>

    </x-content-subheader>
    <x-table title="customers ">
        <x-slot name="header">
            <x-header-dates route="{{ route('customers.index') }}" />
        </x-slot>
        <x-slot name="tableheader">
            <tr>
                <th scope="col"></th>

                <th scope="col">@sortablelink('id', '#')</th>
                <th scope="col">@sortablelink('name','name') </th>
                <th scope="col">@sortablelink('ar_name','ar_name ') </th>
                <th scope="col">@sortablelink('fr_name','fr_name ') </th>
                <th scope="col">Image</th>

            </tr>
        </x-slot>
        <x-slot name="tablebody">
            @foreach ($data as $row)
                <tr>
                    <th scope="row">
                        <x-operations>
                            <x-operation-button type="button" data-bs-toggle="modal"
                                data-bs-target="#edit-modal-{{ $row->id }}" data-id="{{ $row->id }}"
                                data-url="{{ route('customers.update', $row->id) }}">
                                Edit customer
                            </x-operation-button>

                            <x-operation-button type="button" data-bs-toggle="modal"
                                data-bs-target="#show-modal-{{ $row->id }}" data-id="{{ $row->id }}"
                                data-url="{{ route('customers.show', $row->id) }}">
                                Show customer
                            </x-operation-button>
                            <x-operation-button type="button" data-bs-toggle="modal"
                                data-bs-target="#delete-modal-{{ $row->id }}" class="delete-customer"
                                data-id="{{ $row->id }}" data-url="{{ route('customers.destroy', $row->id) }}">
                                Delete customer
                            </x-operation-button>
                        </x-operations>


                    </th>
                    <td>{{ $row->id }}</td>
                    <td>{{ $row->name }}</td>

                    <td>{{ $row->ar_name }}</td>
                    <td>{{ $row->fr_name }}</td>

                    <td><img width="65" src="{{ asset($row->image) }}" class="zoom"
                            alt="{{ $row->ar_title }}">
                </tr>
                <x-modal formid="Editcust{{ $row->id }}" id="edit-modal-{{ $row->id }}" method="put"
                    action="{{ route('customers.update', $row->id) }}">
                    <x-slot name="header">Edit customer</x-slot>
                    <x-slot name="body"> @include('admin._forms.edit-customer')
                    </x-slot>
                </x-modal>


                <x-modal id="show-modal-{{ $row->id }}" method="get" role="document"
                    action="{{ route('customers.update', $row->id) }}">
                    <x-slot name="header">Show customer</x-slot>
                    <x-slot name="body"> @include('admin._forms.view-customer')
                    </x-slot>
                </x-modal>




                <x-modal id="delete-modal-{{ $row->id }}" method="delete" role="document"
                    action="{{ route('customers.destroy', $row->id) }}">
                    <x-slot name="header">Do you want to delete this customer ?</x-slot>
                    <x-slot name="body">
                    </x-slot>
                </x-modal>
            @endforeach
        </x-slot>
        <x-slot name="tablefooter">
            <div class="d-flex justify-content-center mt-2  ">
                {{ $data->links('vendor.pagination.bootstrap-4') }}
            </div>
        </x-slot>
    </x-table>


@endsection





<style>
    .zoom {
        ransition: transform .2s;
        /* Animation */
        width: 65px;
        margin: 0 auto;
    }

    .zoom:hover {
        transform: scale(3.5);
        /* (150% zoom - Note: if the zoom is too large, it will go outside of the viewport) */
    }

</style>